program FreeOTFE;

uses
  Forms,
  SDUi18n,
  FreeOTFEfrmMain in 'FreeOTFEfrmMain.pas' {frmFreeOTFEMain},
  About_U in 'About_U.pas' {About_F},
  FreeOTFEConsts in 'FreeOTFEConsts.pas',
  FreeOTFEfrmVolProperties in 'FreeOTFEfrmVolProperties.pas' {frmFreeOTFEVolProperties},
  FreeOTFEfrmSelectOverwriteMethod in 'FreeOTFEfrmSelectOverwriteMethod.pas' {frmFreeOTFESelectOverwriteMethod},
  FreeOTFEfrmCDBDump in 'FreeOTFEfrmCDBDump.pas' {frmFreeOTFECDBDump},
  FreeOTFEfrmCDBBackupRestore in 'FreeOTFEfrmCDBBackupRestore.pas' {frmFreeOTFECDBBackupRestore},
  FreeOTFESettings in 'FreeOTFESettings.pas',
  FreeOTFEfrmOptions in 'FreeOTFEfrmOptions.pas' {frmOptions},
  Windows,
  SDUGeneral,
  FreeOTFEfrmGridReport in 'FreeOTFEfrmGridReport.pas' {frmGridReport},
  FreeOTFEfrmGridReport_Hash in 'FreeOTFEfrmGridReport_Hash.pas' {frmGridReport_Hash},
  FreeOTFEfrmGridReport_Cypher in 'FreeOTFEfrmGridReport_Cypher.pas' {frmGridReport_Cypher},
  FreeOTFEfmeOptions_Base in 'FreeOTFEfmeOptions_Base.pas' {fmeOptions_Base: TFrame},
  FreeOTFEfmeOptions_SystemTray in 'FreeOTFEfmeOptions_SystemTray.pas' {fmeOptions_SystemTray: TFrame},
  FreeOTFEfmeOptions_Hotkeys in 'FreeOTFEfmeOptions_Hotkeys.pas' {fmeOptions_Hotkeys: TFrame},
  FreeOTFEfmeOptions_PKCS11 in 'FreeOTFEfmeOptions_PKCS11.pas' {fmeOptions_PKCS11: TFrame},
  FreeOTFEfmeOptions_Autorun in 'FreeOTFEfmeOptions_Autorun.pas' {fmeOptions_Autorun: TFrame},
  FreeOTFEfmeOptions_General in 'FreeOTFEfmeOptions_General.pas' {fmeOptions_General: TFrame},
  FreeOTFEfrmInstallOnUSBDrive in 'FreeOTFEfrmInstallOnUSBDrive.pas' {frmInstallOnUSBDrive};

{$R *.RES}

var
  otherRunningAppWindow: THandle;
  CommandLineOnly: boolean;
  cmdExitCode: integer;

begin
  GLOBAL_VAR_WM_FREEOTFE_RESTORE := RegisterWindowMessage('FREEOTFE_RESTORE');
  GLOBAL_VAR_WM_FREEOTFE_REFRESH := RegisterWindowMessage('FREEOTFE_REFRESH');

  Application.Initialize;
{$IFDEF VER185}
  // Vista fix for Delphi 2007 and later
  Application.MainFormOnTaskbar := TRUE;
{$ENDIF}
  Application.Title := 'FreeOTFE';

  FreeOTFESettings.Settings:= TFreeOTFESettings.Create();
  try
    FreeOTFESettings.Settings.Load();

    Application.ShowMainForm := FALSE;
    // NOTE: The main form's Visible property is set to FALSE anyway - it *HAS*
    // to be, otherwise it'll be displayed; dispite the following two lines
    Application.CreateForm(TfrmFreeOTFEMain, frmFreeOTFEMain);
    frmFreeOTFEMain.Visible := FALSE;
    Application.ShowMainForm := FALSE;

    CommandLineOnly := frmFreeOTFEMain.HandleCommandLineOpts(cmdExitCode);


    //   if we were called with no command line arguments then
    //     if no running app was found then
    //       we continue to run the main app
    //     else
    //       we raise the previous application to the top
    //   else
    //     quit (ran with command line arguments)

    // if we were called with no command line arguments then
    if (not(CommandLineOnly)) then
      begin
      otherRunningAppWindow := SDUDetectExistingApp();
      // If no running app was found then
      if (
          (otherRunningAppWindow = 0) or
          Settings.OptAllowMultipleInstances
         ) then
        begin
        // We continue to run the main app
        frmFreeOTFEMain.Visible := TRUE;
        Application.ShowMainForm := TRUE;
        frmFreeOTFEMain.InitApp();
        Application.Run;
        end
      else
        begin
        // Poke already running application
{$IFDEF VER185}
        SendMessage(HWND_BROADCAST, GLOBAL_VAR_WM_FREEOTFE_RESTORE, 0, 0);
{$ELSE}
        SDUPostMessageExistingApp(GLOBAL_VAR_WM_FREEOTFE_RESTORE, 0, 0);
{$ENDIF}

// Alternativly:
//         SetForegroundWindow(otherRunningAppWindow);
        end;
      end
    else
      begin
      // Do nothing; ran with command line arguments, already processed
      end;

  finally
    // Note: We *don't* free of the Settings object if the main form was shown;
    //       the main form is still closing down at this stage, and this causes
    //       an exception.
    //       Instead, this is free'd off in the FormDestroy(...) method
    if not(Application.ShowMainForm) then
      begin
      FreeOTFESettings.Settings.Free();
      end;
  end;

  if (
      CommandLineOnly and
      (cmdExitCode <> CMDLINE_SUCCESS)
     ) then
    begin
    Halt(cmdExitCode); // Note: System.ExitCode may be tested in finalization sections
    end;

END.

